@ -1,10 +1,9 @@
#!/usr/bin/env bash
# Setup script environment
set -o errexit #Exit immediately if a pipeline returns a non-zero status
set -o errtrace #Trap ERR from shell functions, command substitutions, and commands from subshell
set -o nounset #Treat unset variables as an error
set -o pipefail #Pipe will exit with last non-zero status if applicable
set -o errexit
set -o errtrace
set -o nounset
set -o pipefail
shopt -s expand_aliases
alias die = 'EXIT=$? LINE=$LINENO error_exit'
CROSS = '\033[1;31m\xE2\x9D\x8C\033[0m'
@ -28,8 +27,7 @@ function msg() {
echo -e " $TEXT "
}
# Prepare container OS
msg "Setting up Container OS..."
echo -e " ${ CHECKMARK } \e[1;92m Setting up Container OS... \e[0m "
sed -i " / $LANG / s/\(^# \)// " /etc/locale.gen
locale-gen >/dev/null
while [ " $( hostname -I) " = "" ] ; do
@ -44,30 +42,26 @@ while [ "$(hostname -I)" = "" ]; do
done
echo -e " ${ CHECKMARK } \e[1;92m Network Connected: \e[0m $( hostname -I) "
# Update container OS
msg "Updating Container OS..."
echo -e " ${ CHECKMARK } \e[1;92m Updating Container OS... \e[0m "
apt-get update & >/dev/null
apt-get -qqy upgrade & >/dev/null
# Install prerequisites
msg "Installing Prerequisites..."
echo -e " ${ CHECKMARK } \e[1;92m Installing Dependencies... \e[0m "
apt-get update & >/dev/null
apt-get -qqy install \
curl \
sudo & >/dev/null
# Installing pip3
msg "Installing pip3..."
apt-get install python3-pip -y & >/dev/null
# Install ESPHome;
msg "Installing ESPHome..."
pip3 install esphome & >/dev/null
# Installing ESPHome Dashboard
msg "Installing ESPHome Dashboard..."
pip3 install tornado esptool & >/dev/null
echo "Creating service file esphomeDashboard.service"
service_path = "/etc/systemd/system/esphomeDashboard.service"
echo -e " ${ CHECKMARK } \e[1;92m Installing pip3... \e[0m "
apt-get install python3-pip -y & >/dev/null
echo -e " ${ CHECKMARK } \e[1;92m Installing ESPHome... \e[0m "
pip3 install esphome & >/dev/null
echo -e " ${ CHECKMARK } \e[1;92m Installing ESPHome Dashboard... \e[0m "
pip3 install tornado esptool & >/dev/null
service_path = "/etc/systemd/system/esphomeDashboard.service"
echo " [Unit]
Description = ESPHome Dashboard
After = network.target
@ -78,12 +72,11 @@ User=root
[ Install]
WantedBy = multi-user.target" > $service_path
systemctl enable esphomeDashboard.service & >/dev/null
systemctl start esphomeDashboard
# Customize container
msg "Customizing Container..."
rm /etc/motd # Remove message of the day after login
rm /etc/update-motd.d/10-uname # Remove kernel information after login
touch ~/.hushlogin # Remove 'Last login: ' and mail notification after login
echo -e " ${ CHECKMARK } \e[1;92m Customizing Container... \e[0m "
rm /etc/motd
rm /etc/update-motd.d/10-uname
touch ~/.hushlogin
GETTY_OVERRIDE = "/etc/systemd/system/container-getty@1.service.d/override.conf"
mkdir -p $( dirname $GETTY_OVERRIDE )
cat << EOF > $GE TTY_OVERRIDE
@ -93,7 +86,6 @@ ExecStart=-/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,3840
EOF
systemctl daemon-reload
systemctl restart $( basename $( dirname $GETTY_OVERRIDE ) | sed 's/\.d//' )
# Cleanup container
msg "Cleanup..."
systemctl start esphomeDashboard
echo -e " ${ CHECKMARK } \e[1;92m Cleanup... \e[0m "
rm -rf /esphome_setup.sh /var/{ cache,log} /* /var/lib/apt/lists/*